var __reflect = (this && this.__reflect) || function (p, c, t) {
    p.__class__ = c, t ? t.push(c) : t = [c], p.__types__ = p.__types__ ? t.concat(p.__types__) : t;
};
var __extends = this && this.__extends || function __extends(t, e) { 
 function r() { 
 this.constructor = t;
}
for (var i in e) e.hasOwnProperty(i) && (t[i] = e[i]);
r.prototype = e.prototype, t.prototype = new r();
};
/**
 *
 * @author
 *
 */
var GameBridge = (function (_super) {
    __extends(GameBridge, _super);
    function GameBridge() {
        return _super.call(this) || this;
    }
    GameBridge.addEventListener = function (type, listener, thisObject, useCapture, priority) {
        GameBridge.instance().addEventListener(type, listener, thisObject, useCapture, priority);
    };
    GameBridge.dispatchEventWith = function (type, bubbles, data) {
        return GameBridge.instance().dispatchEventWith(type, bubbles, data);
    };
    GameBridge.removeEventListener = function (type, listener, thisObject, useCapture) {
        GameBridge.instance().removeEventListener(type, listener, thisObject, useCapture);
    };
    GameBridge.hasEventListener = function (type) {
        return GameBridge.instance().hasEventListener(type);
    };

    GameBridge.loadingReady = function() {
        if(window.NativeBridge) {
            window.NativeBridge.ready();
        }
    };

    GameBridge.sendEmoji = function(url) {
        GameBridge.sendMessage("emoji", url);
    };

    GameBridge.shake = function(millseconds) {
        if(window.NativeBridge) {
            try {
                window.NativeBridge.shake(millseconds);
            } catch(e) {
            }
        }
    };

	GameBridge.shakeTest = function(){
	    window.setTimeout(function(){
	       GameBridge.shake(100);
           GameBridge.shakeTest();
        }, 3000);
	};

	GameBridge.getGameInfo = function() {
	    //return JSON.parse("{\"port\": 3014,\"gname\": \"一起吹牛\",\"game_name\": \"一起吹牛\",\"players\": [{\"ai\": 0,\"gender\": \"男\",\"icon\": \"https://thirdqq.qlogo.cn/qqapp/1105882648/E7AA1F140A27D1CD20B9B32ED715D5AB/100\",\"id\": \"5ac33f036d196b02e0dc7898\",\"name\": \"啊啊啊啊\"},{\"gender\": \"女\",\"icon\": \"http://p300grq4f.bkt.clouddn.com/RobotFemale/30000002.jpg\",\"id\": \"5a7c54496d196b0814dc9561\",\"name\": \"巴巴爸爸\"}],\"ai\": 1,\"host\": \"139.199.100.168\",\"resource\": \"http://139.199.100.168/yaoshaizi\",\"game_id\": 2,\"rid\": \"5ad4b9a36d196b19443a3c59\",\"gid\": 2,\"pid\": \"5ac33f036d196b02e0dc7898\"}");
		if(window.NativeBridge) {
			return JSON.parse(window.NativeBridge.getGameInfo());
		} else {
			var game = {
				host: "",
				resource: "",
				port: 3014,
				gid: GameBridge.getQueryString("gid"),
				gname: GameBridge.getQueryString("gname"),
				pid: GameBridge.getQueryString("pid"),
				rid: GameBridge.getQueryString("rid"),
				players: [],
				ai: GameBridge.getQueryString("ai") == "1"
			};
			
			var count = parseInt(GameBridge.getQueryString("pc"));
			if(count > 0) {
				for(var i = 0; i < count; i++) {
					game.players.push({
						id: GameBridge.getQueryString("pid" + (i + 1)),
						name: GameBridge.getQueryString("pname" + (i + 1)),
						icon: GameBridge.getQueryString("picon" + (i + 1))
					});
				}
			}

			return game;
		}
	};
	
	GameBridge.setVolume = function(v) {
        if(AudioManager) {
		    AudioManager.setVolume(v);
		}
	};
	
	GameBridge.getPlayer = function(callback) {
		for(var i = 0; i < GameBridge.game_info.players.length; i++) {
			if(callback(GameBridge.game_info.players[i])) {
				return GameBridge.game_info.players[i];
			}
		}
	};
	
	GameBridge.reportLoadingProgress = function(p) {
	    if(GameBridge.game_info.players.length == 2) {
		    GameBridge.sendMessage("loading-progress", p);
		}
	};
	
	GameBridge.reportLoadingComplete = function() {
	    if(GameBridge.game_info.players.length == 2) {
		    GameBridge.sendMessage("loading-complete", "1");
		}
	};
	
	GameBridge.ready = function() {
		if(GameBridge.game_info.players.length > 1 && !GameBridge.game_info.ai) {
			GameBridge.sendMessage("ready", "");
			if(GameBridge.game_info.players.length == 2 && GameBridge.getQueryString("from") != "share") {
			    if(GameBridge.timer) {
			        window.clearTimeout(GameBridge.timer);
			    }

				GameBridge.timer = window.setTimeout(function(){
					GameBridge.pomelo.request("chat.chatHandler.check", {}, function(data) {
						if(data.users.length > 0 && GameBridge.game_info.players.length > data.users.length) {
							var fg = GameBridge.getPlayer(function(d) {
								return d.id != GameBridge.game_info.pid;
							});

                            if(GameBridge.game_info.pid == data.users[0]){
                                GameBridge.dispatchEventWith("onLeave", false, {"route":"onLeave","user":fg.id});
                                //GameBridge.reportGameResult({my_chengji:1,fighter_chengji:0});
                            }
							//GameBridge.dispatchEventWith("onLeave", false, {"route":"onLeave","user":fg.id});
						}
					});
				}, 10000);
			}
		} else {
			GameBridge.dispatchEventWith("startGame", false, { from: GameBridge.game_info.pid, target:"*" });
		}
	};
	
	GameBridge.startGame = function() {
		if(GameBridge.game_info.players.length > 1 && !GameBridge.game_info.ai) {
		    if(GameBridge.hasStartedGame)
		    {
		        return;
		    }

		    GameBridge.hasStartedGame = true;
			GameBridge.sendMessage("startGame", "");
		} else {
			GameBridge.dispatchEventWith("startGame", false, { from: GameBridge.game_info.pid, target:"*" });
		}
		
	};
	
	GameBridge.init = function(msgCallback) {
		egret.ImageLoader.crossOrigin = "anonymous";
		GameBridge.game_info = GameBridge.getGameInfo();
		GameBridge.msgCallback = msgCallback;
		GameBridge.isConnected = false;
		if(GameBridge.game_info.players.length > 1 && !GameBridge.game_info.ai) {
		    GameBridge.pomelo = new Pomelo();
            GameBridge.pomelo.on('onAdd', function (response) {
                GameBridge.msgCallback('onAdd', response);
                GameBridge.dispatchEventWith('onAdd', false, response);
            });

            GameBridge.pomelo.on('onMessage', function (response) {
                if(response.type == "loading-progress" || response.type == "loading-complete") {
                    GameBridge.dispatchEventWith(response.type, false, { uid: response.from, value: response.msg });
                    GameBridge.msgCallback(response.type, response);
                } else {
                    GameBridge.msgCallback('onMessage', response);
                    console.log(response);

                    if(response.type == "ready") {
                        var length = 0;
                        for(var i = 0; i < GameBridge.game_info.players.length; i++) {
                            if(GameBridge.game_info.players[i].id == response.from) {
                                GameBridge.game_info.players[i].ready = true;
                            }
                        }

                        for(var i = 0; i < GameBridge.game_info.players.length; i++) {
                            if(GameBridge.game_info.players[i].ready) {
                                length++;
                            }
                        }

                        if(length >= GameBridge.game_info.players.length) {
                            GameBridge.startGame();
                        }
                    } else {
                        GameBridge.dispatchEventWith(response.type, false, response);
                    }
                }
            });

            GameBridge.pomelo.on('onLeave', function (response) {
                GameBridge.msgCallback('onLeave', response);
                GameBridge.dispatchEventWith("onLeave", false, response);
                //console.log("onLeave1111");
                //console.log(JSON.stringify(response));
            });

            GameBridge.pomelo.init({
                host: GameBridge.game_info.host,
                port: GameBridge.game_info.port
            }, function (response) {
                //console.log(response);
                if (response.code === 200) {

                    GameBridge.pomelo.request('gate.gateHandler.queryEntry', {
                        uid: GameBridge.game_info.pid
                    }, function (data) {
                        GameBridge.pomelo.disconnect();//断开gate服务器，连接connector服务器
                        if (data.code === 500) {
                            GameBridge.msgCallback("close", true);
                            GameBridge.dispatchEventWith("connection", false, false);
                            return;
                        }
                        //console.log(data)
                        GameBridge.connection_info = data;
                        GameBridge.connectServer();
                    });
                }
            });
		} else {
		    GameBridge.msgCallback("connected", true);
		    GameBridge.dispatchEventWith("connection", false, true);
		}
	};

	GameBridge.connectServer = function(){
	    var param = { rid: GameBridge.game_info.rid, username: GameBridge.game_info.pid};
	    GameBridge.pomelo.init({
                                    host: GameBridge.connection_info.host,
                                    port: GameBridge.connection_info.port
                                }, function (response) {
                                    if (response.code === 200) {
                                        //console.log("服务器id：" + User.server_id)
                                        GameBridge.pomelo.request(
                                            'connector.entryHandler.enter',
                                            param,
                                            function (data) {
                                                GameBridge.msgCallback("connected", true);
                                                GameBridge.dispatchEventWith("connection", false, true);
                                                GameBridge.isConnected = true;
                                                GameBridge.pomelo.on('close', function (e) {
                                                    console.log("连接断开了");
                                                    console.log("close__");
                                                    GameBridge.isConnected = false;
                                                    GameBridge.msgCallback("close", true);
                                                    GameBridge.dispatchEventWith("connection", false, false);
                                                });

                                            });
                                    } else {
                                        GameBridge.msgCallback("close", true);
                                        GameBridge.dispatchEventWith("connection", false, false);
                                    }
                                });
	};

	GameBridge.get_game_info = function() {
		return GameBridge.game_info;
	};
	
	GameBridge.sendMessage = function(type, content, target) {
		if(!target) {
			target = "*";
		}
		
		var msg = { type: type, content: content, target: target};
		if(GameBridge.game_info.players.length > 1 && !GameBridge.game_info.ai) {
            GameBridge.pomelo.request("chat.chatHandler.send", msg, function(data) {

            });
		} else {
		    var response = { msg : content, type: type, from: GameBridge.game_info.pid, target:target};
		    if(response.type == "loading-progress" || response.type == "loading-complete") {
                GameBridge.dispatchEventWith(response.type, false, { uid: response.from, value: response.msg });
                GameBridge.msgCallback(response.type, response);
            } else {
                GameBridge.msgCallback('onMessage', response);
                //console.log(response);

                if(response.type == "ready") {
                    var length = 0;
                    for(var i = 0; i < GameBridge.game_info.players.length; i++) {
                        if(GameBridge.game_info.players[i].id == response.from) {
                            GameBridge.game_info.players[i].ready = true;
                        }
                    }

                    for(var i = 0; i < GameBridge.game_info.players.length; i++) {
                        if(GameBridge.game_info.players[i].ready) {
                            length++;
                        }
                    }

                    if(length >= GameBridge.game_info.players.length) {
                        GameBridge.startGame();
                    }
                } else {
                    GameBridge.dispatchEventWith(response.type, false, response);
                }
            }

		}
	};
	
	GameBridge.getQueryString = function(key) {
		// 获取参数
		var url = window.location.search;
		// 正则筛选地址栏
		var reg = new RegExp("(^|&)" + key + "=([^&]*)(&|$)");
		// 匹配目标参数
		var result = url.substr(1).match(reg);
		//返回参数值
		return result ? decodeURIComponent(result[2]) : key;
	};
	
	GameBridge.reportGameResult = function(r, callback) {
	    if(GameBridge.timer) {
            window.clearTimeout(GameBridge.timer);
        }

		if(window.NativeBridge && window.JKEventHandlerEvent) {
		    if(GameBridge.game_info.players.length > 1) {
                window.JKEventHandlerEvent.addEvent("reportGameResult_Callback", function(d) {
                    if(GameBridge.game_info.players.length > 1 && !GameBridge.game_info.ai) {
                        GameBridge.pomelo.disconnect();
                    }

                    callback(d);
                });
		    }

			window.NativeBridge.reportGameResult(JSON.stringify(r));
		} else {
            var result = r;
            var d = 0;
            if(result.my_chengji > result.fighter_chengji) {
                d = 1;
            } else if(result.my_chengji < result.fighter_chengji) {
                d = -1;
            }

            callback(d);

			if(GameBridge.game_info.players.length > 1 && !GameBridge.game_info.ai) {
                 if(GameBridge.game_info.players.length > 1 && !GameBridge.game_info.ai) {
                      GameBridge.pomelo.disconnect();
                 }
            }
		}
	};

	GameBridge.close = function(){
	    if(GameBridge.timer) {
            window.clearTimeout(GameBridge.timer);
        }

	    if(GameBridge.game_info.players.length > 1 && !GameBridge.game_info.ai) {
            GameBridge.pomelo.disconnect();
        }

        GameBridge.msgCallback("close", true);
        GameBridge.dispatchEventWith("connection", false, false);
	};
	
    GameBridge.instance = function () {
        if (GameBridge._instance == null) {
            GameBridge._instance = new GameBridge();
        }
        return GameBridge._instance;
    };
	
    return GameBridge;
}(egret.EventDispatcher));
__reflect(GameBridge.prototype, "GameBridge");