var NativeBridgeContext = {
    postData:function(option, callBack){
        if(JKEventHandler.isiOS()) {
            JKEventHandler.callNativeFunction("postData", JSON.stringify(option),function(data){
                                                      callBack(data);
                                                      });
        } else {
            if(window.NativeBridge) {
                var callBackName = JKEventHandler.addCallback("postData", callBack);
                window.NativeBridge.postData(JSON.stringify(option), callBackName);
            } else {
                $.ajax({
                    url: option.url,
					data: data,
					headers: {
						token: ""
					},
					success: function(data){
						callBack(data);
					}
                });
            }
        }
    }
}
var JKEventHandler ={
    isiOS: function(){
        var u = navigator.userAgent, app = navigator.appVersion;
        var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Linux') > -1; //android终端或者uc浏览器
        var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
        return isiOS;
    },

callNativeFunction:function(functionString,params,callBack){
    
    var methodName = (functionString.replace(/function\s?/mi,"").split("("))[0];
    var callBackName =methodName + '_CallBack_' + Event.uuid();
    var message;
    
    if(!callBack){
        
        message = {'methodName':methodName,'params':params};
        window.webkit.messageHandlers.JKEventHandler.postMessage(message);
        
    }else{
        message = {'methodName':methodName,'params':params,'callBackName':callBackName};
        if(!Event._listeners[callBackName]){
            Event.addEvent(callBackName, function(data){
                           
                           callBack(data);
                           
                           });
        }
        window.webkit.messageHandlers.JKEventHandler.postMessage(message);
    }
    
    
},

addCallback: function(functionString, callBack) {
    var methodName = (functionString.replace(/function\s?/mi,"").split("("))[0];
    var callBackName =methodName + '_CallBack_' + Event.uuid();
        if(!Event._listeners[callBackName]){
            Event.addEvent(callBackName, function(data){

                           callBack(data);

                           });
        }

        return callBackName;
},
    
callBack:function(callBackName,data){
    
    Event.fireEvent(callBackName,data);
    
},
    
removeAllCallBacks:function(data){
    Event._listeners ={};
}
    
};



var Event = {
    
_listeners: {},
    
    
addEvent: function(type, fn) {
    if (typeof this._listeners[type] === "undefined") {
        this._listeners[type] = [];
    }
    if (typeof fn === "function") {
        this._listeners[type].push(fn);
    }
    
    return this;
},

 uuid: function () {
     var s = [];
     var hexDigits = "0123456789abcdef";
     for (var i = 0; i < 36; i++) {
         s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
     }
     s[14] = "4";  // bits 12-15 of the time_hi_and_version field to 0010
     s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1);  // bits 6-7 of the clock_seq_hi_and_reserved to 01
     s[8] = s[13] = s[18] = s[23] = "-";

     var uuid = s.join("");
     return uuid;
 },
    
    
fireEvent: function(type,param) {
    var arrayEvent = this._listeners[type];
    if (arrayEvent instanceof Array) {
        for (var i=0, length=arrayEvent.length; i<length; i+=1) {
            if (typeof arrayEvent[i] === "function") {
                arrayEvent[i](param);
            }
        }
    }
    
    return this;
},
    
removeEvent: function(type, fn) {
    var arrayEvent = this._listeners[type];
    if (typeof type === "string" && arrayEvent instanceof Array) {
        if (typeof fn === "function") {
            for (var i=0, length=arrayEvent.length; i<length; i+=1){
                if (arrayEvent[i] === fn){
                    this._listeners[type].splice(i, 1);
                    break;
                }
            }
        } else {
            delete this._listeners[type];
        }
    }
    
    return this;
}
};
